package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.dao.model.AnswerEntity;
import com.rf.psychological.dao.model.DimensionEntity;
import com.rf.psychological.scale.dao.model.ScaleMarksEntity;

import java.text.DecimalFormat;
import java.util.*;

/***
 * @author lhl
 * @description:亲社会和攻击性驾驶行为量表
 * @date 2021/11/02 15:55
 */
public class PADICScale extends BaseScale {
    public PADICScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }
    public JSONObject scaleCalculate() throws Exception{
        //总分
        double score = 0;
        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String,String>> resultMapList = new ArrayList<>();
        //获取答案列表
        List<AnswerEntity> answerEntities = (List<AnswerEntity>) resultJson.get("answerEntities");
        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        if (dimensionEntities.size() > 0){
            //计算每个维度得分
            double[] dimensionScore = new double[dimensionEntities.size()];
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jsonObject1 = jsonArray.getJSONObject(i);
                for (int y = 0; y < dimensionEntities.size(); y++) {
                    //for (DimensionEntity dimensionEntity:dimensionEntities){
                    DimensionEntity dimensionEntity = dimensionEntities.get(y);
                    String questionNos = dimensionEntity.getQuestionNo();
                    String[] questionNo = questionNos.split("；");
                    for (String question:questionNo){
                        if (question.equals(jsonObject1.getString("questionNo"))){
                            for (AnswerEntity answerEntity:answerEntities){
                                ///只用比较选项内容，进而判定该题目的分数值
                                if (answerEntity.getQuestionNo().equals(question) &&answerEntity.getName().equals(jsonObject1.getString("checkItems"))){
                                    dimensionScore[y] += Double.valueOf(answerEntity.getScore());
                                }
                            }
                            break;
                        }
                    }
                }

                //计算总分
                /*for (AnswerEntity answerEntity:answerEntities){
                    if (answerEntity.getQuestionNo().equals(String.valueOf(i+1))){
                        if (answerEntity.getName().equals(jsonObject1.getString("checkItems"))){
                            score += Integer.valueOf(answerEntity.getScore());
                        }
                    }
                }*/
            }

          /*  resultMap0.put("DBS总分", String.valueOf(score));
            resultJson.put("DBS总分", String.valueOf(score));*/
            //计算每个维度的平均分
            DecimalFormat df = new DecimalFormat("######0.00");
            double[] Mdscore = new double[dimensionScore.length];
            Mdscore[0]= Double.parseDouble(df.format(dimensionScore[0]/16.0));
            Mdscore[1]= Double.parseDouble(df.format(dimensionScore[1]/12.0));

            resultMap0.put("2c91f37d7bec0878017c43ddb10842fd", String.valueOf(Mdscore[0]));
            resultMap0.put("攻击性驾驶行为维度均分", String.valueOf(Mdscore[1]));
            Map<String,Double> dimensionScoreMap = new HashMap<>();
            dimensionScoreMap.put("2c91f37d7bec0878017c43ddb10842fd",Mdscore[0]);
            dimensionScoreMap.put("2c91f37d7bec0878017c43ddb14c42fe",Mdscore[1]);
            resultJson.put("dimensionScoreMap",dimensionScoreMap);

            resultJson.put("亲社会驾驶行为维度均分", String.valueOf(Mdscore[0]));
            resultJson.put("攻击性驾驶行为维度均分", String.valueOf(Mdscore[1]));




            resultMapList.add(resultMap0);
        }

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",resultJson.getString("scaleName"));
        returnJson.put("resultJson",resultJson);

        return returnJson;

    }
}
